/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.2 Beta1 Standard
Automatic Program Generator
 Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 13.03.2007
Author  : Feodor                          
Company : ADN                             
Comments: 


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 10,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
#include <m8_128.h> //   http://avr123.nm.ru/m8_128.h 
#include <stdio.h>
#include <stdlib.h>
#include <delay.h> 

#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7  

#define OUT_PORT PORTD //  
#define OUT_RF 4       // 
#define OUT_RB 5       // 
#define OUT_LF 6       // 
#define OUT_LB 7       // 

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// USART Receiver buffer
#define RX_BUFFER_SIZE 8
char rx_buffer[RX_BUFFER_SIZE];   



#if RX_BUFFER_SIZE<256
unsigned char rx_wr_index,rx_rd_index,rx_counter;
#else
unsigned int rx_wr_index,rx_rd_index,rx_counter;
#endif

// This flag is set on USART Receiver buffer overflow
bit rx_buffer_overflow;  
char buffer[3],simvol, pwm; 
char i=0;



// USART Receiver interrupt service routine
interrupt [USART_RXC] void usart_rx_isr(void)
{
char status,data,;
status=UCSRA;
data=UDR;
if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
{
        rx_buffer[rx_wr_index]=data;
        if (++rx_wr_index == RX_BUFFER_SIZE) rx_wr_index=0;
        if (++rx_counter == RX_BUFFER_SIZE)
                {
                rx_counter=0;
                rx_buffer_overflow=1;
                }
                                                                
        simvol = getchar(); 
        if ((simvol == 'R')|(simvol == 'L')|(simvol == '#')) 
                {
                i = 0;
                buffer[i] = simvol;
                i++;
                } 
        if (i)
                {   
                if (((simvol >= '0')&(simvol <= '9')))  
                        {
                        buffer[i] = simvol;
                        i++;
                        }
                }  
        if (i > 2) 
{
i =0;
putsf("\r\nGood"); //   
{ 
if  ( buffer[0] == 'R' )
        {
        if  (( buffer[1] == '5') | ( buffer[2] == '5'))
        {
                OUT_PORT = ( OUT_PORT & (~(1<<OUT_RB)) ) & (~(1<<OUT_RF));
                pwm = 0;
                putsf("\r\nRMot: STOP");
        }
        if  ( ('6' <= buffer[1]) | (buffer[1] <= '9') )
        {
                // ( PORTD & 11110111 ) | 00000100
                OUT_PORT = ( OUT_PORT & (~(1<<OUT_RB)) ) | (1<<OUT_RF);
                pwm = (buffer[1] - '0')*10 + (buffer[2] - '0');
                putsf("\r\nRMot: FWD");
        }
        if  ( ('0' <= buffer[1]) | (buffer[1] <= '4') )
        {
                OUT_PORT = ( OUT_PORT & (~(1<<OUT_RF)) ) | (1<<OUT_RB);
                pwm = (buffer[1] - '0')*10 + (buffer[2] - '0');
                putsf("\r\nRMot: BWD");
        }
} 
if  ( buffer[0] == 'L' )  
        {
        if  ( buffer[1] == '5' )
        {
                OUT_PORT = ( OUT_PORT & (~(1<<OUT_LB)) ) & (~(1<<OUT_LF));
                pwm = 0;
                putsf("\r\nLMot: STOP");
        }
        if  ( ('6' <= buffer[1]) | (buffer[1] <= '9') )
        {
                // ( PORTD & 11110111 ) | 00000100
                OUT_PORT = ( OUT_PORT & (~(1<<OUT_LB)) ) | (1<<OUT_LF);
                pwm = (buffer[1] - '0')*10 + (buffer[2] - '0');
                putsf("\r\nLMot: FWD");
        }
        if  ( ('0' <= buffer[1]) | (buffer[1] <= '4') )
        {
                OUT_PORT = ( OUT_PORT & (~(1<<OUT_LF)) ) | (1<<OUT_LB);
                pwm = (buffer[1] - '0')*10 + (buffer[2] - '0');
                putsf("\r\nLMot: BWD");
        }
}  
}
        } 
if (buffer[0] == '#')
        {
        if ((buffer[1] == '1')|(buffer[0] == '0'))    
                                                //  ADC
        putsf("\r\n100%"); 
        if ((buffer[1] == '2')|(buffer[0] == '3'))
        putsf("\r\n #23");
                                                 //    
                                                 //1   2          
        }                       
 }
 }



#ifndef _DEBUG_TERMINAL_IO_
// Get a character from the USART Receiver buffer
#define _ALTERNATE_GETCHAR_
#pragma used+
char getchar(void)
{
char data;
while (rx_counter==0);
data=rx_buffer[rx_rd_index];
if (++rx_rd_index == RX_BUFFER_SIZE) rx_rd_index=0;
#asm("cli")
--rx_counter;
#asm("sei")
return data;
}
#pragma used-
#endif

// Standard Input/Output functions
// Declare your global variables here
             


//    
void send_ping(void)    
{
        for(i=0;i<10;i++)
        {
        PORTC.2 = 0;
        delay_us(14); //  36
        PORTC.2 = 1;
        delay_us(14);
        }
}  

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=In Func0=In 
// State7=T State6=T State5=0 State4=0 State3=0 State2=0 State1=P State0=P 
PORTD=0x03;
DDRD=0x3C;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud rate: 9600
UCSRA=0x00;
UCSRB=0x98;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x40;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// Global enable interrupts
#asm("sei")

while (1)
      {
      // Place your code here
      putsf("\r\n |");
      delay_ms(500);
      send_ping();
      delay_us(900);  
      //           
      //    2     ,      
      }; 
}
    






















